/* upstart
 *
 * com.ubuntu.Upstart.Instance.c - Auto-generated d-bus bindings
 *
 * Copyright © 2008 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */


#include <dbus/dbus.h>

#include <errno.h>
#include <limits.h>

#include <nih/macros.h>
#include <nih/alloc.h>
#include <nih/string.h>
#include <nih/logging.h>
#include <nih/error.h>
#include <nih/errors.h>
#include <nih/dbus.h>

#include "com.ubuntu.Upstart.Instance.h"


/* Prototypes for handler functions */
extern int job_start   (void *data, NihDBusMessage *message);
extern int job_stop    (void *data, NihDBusMessage *message);
extern int job_restart (void *data, NihDBusMessage *message);


/* Prototypes for static functions */
static DBusHandlerResult com_ubuntu_Upstart_Instance_Start_marshal   (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Instance_Stop_marshal    (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Instance_Restart_marshal (NihDBusObject *object, NihDBusMessage *message);


static const NihDBusArg com_ubuntu_Upstart_Instance_Start_args[] = {
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Instance_Stop_args[] = {
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Instance_Restart_args[] = {
	{ NULL }
};

const NihDBusMethod com_ubuntu_Upstart_Instance_methods[] = {
	{ "Start",   com_ubuntu_Upstart_Instance_Start_marshal,   com_ubuntu_Upstart_Instance_Start_args   },
	{ "Stop",    com_ubuntu_Upstart_Instance_Stop_marshal,    com_ubuntu_Upstart_Instance_Stop_args    },
	{ "Restart", com_ubuntu_Upstart_Instance_Restart_marshal, com_ubuntu_Upstart_Instance_Restart_args },
	{ NULL }
};

const NihDBusSignal com_ubuntu_Upstart_Instance_signals[] = {
	{ NULL }
};

const NihDBusInterface com_ubuntu_Upstart_Instance = {
	"com.ubuntu.Upstart.Instance",
	com_ubuntu_Upstart_Instance_methods,
	com_ubuntu_Upstart_Instance_signals,
	NULL
};


static DBusHandlerResult
com_ubuntu_Upstart_Instance_Start_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Start method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_start (object->data, message) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
job_start_reply (NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);


	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

static DBusHandlerResult
com_ubuntu_Upstart_Instance_Stop_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Stop method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_stop (object->data, message) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
job_stop_reply (NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);


	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

static DBusHandlerResult
com_ubuntu_Upstart_Instance_Restart_marshal (NihDBusObject  *object,
                                             NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Restart method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_restart (object->data, message) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
job_restart_reply (NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);


	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

