/* upstart
 *
 * com.ubuntu.Upstart.Job.c - Auto-generated d-bus bindings
 *
 * Copyright © 2008 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */


#include <dbus/dbus.h>

#include <errno.h>
#include <limits.h>

#include <nih/macros.h>
#include <nih/alloc.h>
#include <nih/string.h>
#include <nih/logging.h>
#include <nih/error.h>
#include <nih/errors.h>
#include <nih/dbus.h>

#include "com.ubuntu.Upstart.Job.h"


/* Prototypes for handler functions */
extern int job_class_get_instance         (void *data, NihDBusMessage *message, char * const *env, char **instance);
extern int job_class_get_instance_by_name (void *data, NihDBusMessage *message, const char *name, char **instance);
extern int job_class_get_all_instances    (void *data, NihDBusMessage *message, char ***instances);
extern int job_class_start                (void *data, NihDBusMessage *message, char * const *env);
extern int job_class_stop                 (void *data, NihDBusMessage *message, char * const *env);
extern int job_class_restart              (void *data, NihDBusMessage *message, char * const *env);


/* Prototypes for static functions */
static DBusHandlerResult com_ubuntu_Upstart_Job_GetInstance_marshal       (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Job_GetInstanceByName_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Job_GetAllInstances_marshal   (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Job_Start_marshal             (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Job_Stop_marshal              (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_Job_Restart_marshal           (NihDBusObject *object, NihDBusMessage *message);


static const NihDBusArg com_ubuntu_Upstart_Job_GetInstance_args[] = {
	{ "env",      "as", NIH_DBUS_ARG_IN  },
	{ "instance", "o",  NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_GetInstanceByName_args[] = {
	{ "name",     "s", NIH_DBUS_ARG_IN  },
	{ "instance", "o", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_GetAllInstances_args[] = {
	{ "instances", "ao", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_Start_args[] = {
	{ "env",      "as", NIH_DBUS_ARG_IN  },
	{ "instance", "o",  NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_Stop_args[] = {
	{ "env", "as", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_Restart_args[] = {
	{ "env",      "as", NIH_DBUS_ARG_IN  },
	{ "instance", "o",  NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_InstanceAdded_args[] = {
	{ "instance", "o", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_Job_InstanceRemoved_args[] = {
	{ "instance", "o", NIH_DBUS_ARG_IN },
	{ NULL }
};

const NihDBusMethod com_ubuntu_Upstart_Job_methods[] = {
	{ "GetInstance",       com_ubuntu_Upstart_Job_GetInstance_marshal,       com_ubuntu_Upstart_Job_GetInstance_args       },
	{ "GetInstanceByName", com_ubuntu_Upstart_Job_GetInstanceByName_marshal, com_ubuntu_Upstart_Job_GetInstanceByName_args },
	{ "GetAllInstances",   com_ubuntu_Upstart_Job_GetAllInstances_marshal,   com_ubuntu_Upstart_Job_GetAllInstances_args   },
	{ "Start",             com_ubuntu_Upstart_Job_Start_marshal,             com_ubuntu_Upstart_Job_Start_args             },
	{ "Stop",              com_ubuntu_Upstart_Job_Stop_marshal,              com_ubuntu_Upstart_Job_Stop_args              },
	{ "Restart",           com_ubuntu_Upstart_Job_Restart_marshal,           com_ubuntu_Upstart_Job_Restart_args           },
	{ NULL }
};

const NihDBusSignal com_ubuntu_Upstart_Job_signals[] = {
	{ "InstanceAdded",   com_ubuntu_Upstart_Job_InstanceAdded_args   },
	{ "InstanceRemoved", com_ubuntu_Upstart_Job_InstanceRemoved_args },
	{ NULL }
};

const NihDBusInterface com_ubuntu_Upstart_Job = {
	"com.ubuntu.Upstart.Job",
	com_ubuntu_Upstart_Job_methods,
	com_ubuntu_Upstart_Job_signals,
	NULL
};


static DBusHandlerResult
com_ubuntu_Upstart_Job_GetInstance_marshal (NihDBusObject  *object,
                                            NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **env;
	DBusMessageIter   env_iter;
	size_t            env_len;
	char             *instance;
	char             *instance_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetInstance method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetInstance method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &env_iter);

	env = NULL;
	env_len = 0;

	while (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_INVALID) {
		char *env_elem;
		char *env_elem_value;

		if (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_STRING) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to GetInstance method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&env_iter, &env_elem_value);

		env_elem = nih_strdup (message, env_elem_value);
		if (! env_elem) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		dbus_message_iter_next (&env_iter);

		env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
		if (! env) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(env)[(env_len)++] = env_elem;

	}

	dbus_message_iter_next (&iter);

	env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
	if (! env) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	(env)[(env_len)] = NULL;

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetInstance method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_class_get_instance (object->data, message, env, &instance) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	instance_value = instance;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &instance_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_Job_GetInstanceByName_marshal (NihDBusObject  *object,
                                                  NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *name;
	char            *name_value;
	char            *instance;
	char            *instance_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetInstanceByName method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &name_value);

	name = nih_strdup (message, name_value);
	if (! name) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetInstanceByName method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_class_get_instance_by_name (object->data, message, name, &instance) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	instance_value = instance;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &instance_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_Job_GetAllInstances_marshal (NihDBusObject  *object,
                                                NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **instances;
	DBusMessageIter   instances_iter;
	size_t            instances_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetAllInstances method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_class_get_all_instances (object->data, message, &instances) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "o", &instances_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	instances_len = 0;
	for (char **instances_p = instances; instances_p && *instances_p; instances_p++) {
		char *instances_elem;
		char *instances_elem_value;

		instances_elem = *instances_p;

		instances_elem_value = instances_elem;
		if (! dbus_message_iter_append_basic (&instances_iter, DBUS_TYPE_OBJECT_PATH, &instances_elem_value)) {
			dbus_message_unref (reply);
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(instances_len)++;
	}

	if (! dbus_message_iter_close_container (&iter, &instances_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_Job_Start_marshal (NihDBusObject  *object,
                                      NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **env;
	DBusMessageIter   env_iter;
	size_t            env_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Start method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Start method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &env_iter);

	env = NULL;
	env_len = 0;

	while (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_INVALID) {
		char *env_elem;
		char *env_elem_value;

		if (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_STRING) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to Start method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&env_iter, &env_elem_value);

		env_elem = nih_strdup (message, env_elem_value);
		if (! env_elem) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		dbus_message_iter_next (&env_iter);

		env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
		if (! env) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(env)[(env_len)++] = env_elem;

	}

	dbus_message_iter_next (&iter);

	env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
	if (! env) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	(env)[(env_len)] = NULL;

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Start method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_class_start (object->data, message, env) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
job_class_start_reply (NihDBusMessage *message,
                       const char     *instance)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	const char      *instance_value;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);

	instance_value = instance;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &instance_value)) {
		dbus_message_unref (reply);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

static DBusHandlerResult
com_ubuntu_Upstart_Job_Stop_marshal (NihDBusObject  *object,
                                     NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **env;
	DBusMessageIter   env_iter;
	size_t            env_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Stop method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Stop method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &env_iter);

	env = NULL;
	env_len = 0;

	while (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_INVALID) {
		char *env_elem;
		char *env_elem_value;

		if (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_STRING) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to Stop method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&env_iter, &env_elem_value);

		env_elem = nih_strdup (message, env_elem_value);
		if (! env_elem) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		dbus_message_iter_next (&env_iter);

		env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
		if (! env) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(env)[(env_len)++] = env_elem;

	}

	dbus_message_iter_next (&iter);

	env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
	if (! env) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	(env)[(env_len)] = NULL;

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Stop method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_class_stop (object->data, message, env) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
job_class_stop_reply (NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);


	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

static DBusHandlerResult
com_ubuntu_Upstart_Job_Restart_marshal (NihDBusObject  *object,
                                        NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **env;
	DBusMessageIter   env_iter;
	size_t            env_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Restart method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Restart method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &env_iter);

	env = NULL;
	env_len = 0;

	while (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_INVALID) {
		char *env_elem;
		char *env_elem_value;

		if (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_STRING) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to Restart method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&env_iter, &env_elem_value);

		env_elem = nih_strdup (message, env_elem_value);
		if (! env_elem) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		dbus_message_iter_next (&env_iter);

		env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
		if (! env) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(env)[(env_len)++] = env_elem;

	}

	dbus_message_iter_next (&iter);

	env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
	if (! env) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	(env)[(env_len)] = NULL;

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Restart method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (job_class_restart (object->data, message, env) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
job_class_restart_reply (NihDBusMessage *message,
                         const char     *instance)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	const char      *instance_value;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);

	instance_value = instance;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &instance_value)) {
		dbus_message_unref (reply);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

int
job_class_instance_added (DBusConnection *connection,
                          const char     *origin_path,
                          const char     *instance)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *instance_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.ubuntu.Upstart.Job", "InstanceAdded");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	instance_value = instance;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &instance_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
job_class_instance_removed (DBusConnection *connection,
                            const char     *origin_path,
                            const char     *instance)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *instance_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.ubuntu.Upstart.Job", "InstanceRemoved");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	instance_value = instance;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &instance_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

