/* upstart
 *
 * com.ubuntu.Upstart.c - Auto-generated d-bus bindings
 *
 * Copyright © 2008 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */


#include <dbus/dbus.h>

#include <errno.h>
#include <limits.h>

#include <nih/macros.h>
#include <nih/alloc.h>
#include <nih/string.h>
#include <nih/logging.h>
#include <nih/error.h>
#include <nih/errors.h>
#include <nih/dbus.h>

#include "com.ubuntu.Upstart.h"


/* Prototypes for handler functions */
extern int control_reload_configuration (void *data, NihDBusMessage *message);
extern int control_get_job_by_name      (void *data, NihDBusMessage *message, const char *name, char **job);
extern int control_get_all_jobs         (void *data, NihDBusMessage *message, char ***jobs);
extern int control_emit_event           (void *data, NihDBusMessage *message, const char *name, char * const *env);
extern int control_get_version          (void *data, NihDBusMessage *message, char **version);
extern int control_set_log_prio         (void *data, NihDBusMessage *message, int32_t priority);


/* Prototypes for static functions */
static DBusHandlerResult com_ubuntu_Upstart_ReloadConfiguration_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_GetJobByName_marshal        (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_GetAllJobs_marshal          (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_EmitEvent_marshal           (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_GetVersion_marshal          (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_ubuntu_Upstart_SetLogPrio_marshal          (NihDBusObject *object, NihDBusMessage *message);


static const NihDBusArg com_ubuntu_Upstart_ReloadConfiguration_args[] = {
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_GetJobByName_args[] = {
	{ "name", "s", NIH_DBUS_ARG_IN  },
	{ "job",  "o", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_GetAllJobs_args[] = {
	{ "jobs", "ao", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_EmitEvent_args[] = {
	{ "name", "s",  NIH_DBUS_ARG_IN },
	{ "env",  "as", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_GetVersion_args[] = {
	{ "version", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_SetLogPrio_args[] = {
	{ "priority", "i", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_JobAdded_args[] = {
	{ "job", "o", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_ubuntu_Upstart_JobRemoved_args[] = {
	{ "job", "o", NIH_DBUS_ARG_IN },
	{ NULL }
};

const NihDBusMethod com_ubuntu_Upstart_methods[] = {
	{ "ReloadConfiguration", com_ubuntu_Upstart_ReloadConfiguration_marshal, com_ubuntu_Upstart_ReloadConfiguration_args },
	{ "GetJobByName",        com_ubuntu_Upstart_GetJobByName_marshal,        com_ubuntu_Upstart_GetJobByName_args        },
	{ "GetAllJobs",          com_ubuntu_Upstart_GetAllJobs_marshal,          com_ubuntu_Upstart_GetAllJobs_args          },
	{ "EmitEvent",           com_ubuntu_Upstart_EmitEvent_marshal,           com_ubuntu_Upstart_EmitEvent_args           },
	{ "GetVersion",          com_ubuntu_Upstart_GetVersion_marshal,          com_ubuntu_Upstart_GetVersion_args          },
	{ "SetLogPrio",          com_ubuntu_Upstart_SetLogPrio_marshal,          com_ubuntu_Upstart_SetLogPrio_args          },
	{ NULL }
};

const NihDBusSignal com_ubuntu_Upstart_signals[] = {
	{ "JobAdded",   com_ubuntu_Upstart_JobAdded_args   },
	{ "JobRemoved", com_ubuntu_Upstart_JobRemoved_args },
	{ NULL }
};

const NihDBusInterface com_ubuntu_Upstart = {
	"com.ubuntu.Upstart",
	com_ubuntu_Upstart_methods,
	com_ubuntu_Upstart_signals,
	NULL
};


static DBusHandlerResult
com_ubuntu_Upstart_ReloadConfiguration_marshal (NihDBusObject  *object,
                                                NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to ReloadConfiguration method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (control_reload_configuration (object->data, message) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);


send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_GetJobByName_marshal (NihDBusObject  *object,
                                         NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *name;
	char            *name_value;
	char            *job;
	char            *job_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetJobByName method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &name_value);

	name = nih_strdup (message, name_value);
	if (! name) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetJobByName method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (control_get_job_by_name (object->data, message, name, &job) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	job_value = job;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &job_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_GetAllJobs_marshal (NihDBusObject  *object,
                                       NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **jobs;
	DBusMessageIter   jobs_iter;
	size_t            jobs_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetAllJobs method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (control_get_all_jobs (object->data, message, &jobs) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "o", &jobs_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	jobs_len = 0;
	for (char **jobs_p = jobs; jobs_p && *jobs_p; jobs_p++) {
		char *jobs_elem;
		char *jobs_elem_value;

		jobs_elem = *jobs_p;

		jobs_elem_value = jobs_elem;
		if (! dbus_message_iter_append_basic (&jobs_iter, DBUS_TYPE_OBJECT_PATH, &jobs_elem_value)) {
			dbus_message_unref (reply);
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(jobs_len)++;
	}

	if (! dbus_message_iter_close_container (&iter, &jobs_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_EmitEvent_marshal (NihDBusObject  *object,
                                      NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char             *name;
	char            **env;
	char             *name_value;
	DBusMessageIter   env_iter;
	size_t            env_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to EmitEvent method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &name_value);

	name = nih_strdup (message, name_value);
	if (! name) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to EmitEvent method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to EmitEvent method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &env_iter);

	env = NULL;
	env_len = 0;

	while (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_INVALID) {
		char *env_elem;
		char *env_elem_value;

		if (dbus_message_iter_get_arg_type (&env_iter) != DBUS_TYPE_STRING) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to EmitEvent method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&env_iter, &env_elem_value);

		env_elem = nih_strdup (message, env_elem_value);
		if (! env_elem) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		dbus_message_iter_next (&env_iter);

		env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
		if (! env) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(env)[(env_len)++] = env_elem;

	}

	dbus_message_iter_next (&iter);

	env = nih_realloc (env, message, sizeof (char *) * ((env_len) + 1));
	if (! env) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	(env)[(env_len)] = NULL;

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to EmitEvent method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (control_emit_event (object->data, message, name, env) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
control_emit_event_reply (NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);


	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

static DBusHandlerResult
com_ubuntu_Upstart_GetVersion_marshal (NihDBusObject  *object,
                                       NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *version;
	char            *version_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to GetVersion method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (control_get_version (object->data, message, &version) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	version_value = version;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &version_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_ubuntu_Upstart_SetLogPrio_marshal (NihDBusObject  *object,
                                       NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int32_t          priority;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to SetLogPrio method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &priority);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to SetLogPrio method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (control_set_log_prio (object->data, message, priority) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);


send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
control_job_added (DBusConnection *connection,
                   const char     *origin_path,
                   const char     *job)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *job_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.ubuntu.Upstart", "JobAdded");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	job_value = job;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &job_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
control_job_removed (DBusConnection *connection,
                     const char     *origin_path,
                     const char     *job)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *job_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.ubuntu.Upstart", "JobRemoved");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	job_value = job;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &job_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

